#include <stdio.h>
#include <errno.h>
#include "coord.h"
#include "nw_setup.h"
#include <stdlib.h>
#include "liblnp.h"

#define PORT "3048"

#define BACKLOG 10

#define MAX_CONNS 100

int am_i_chief = 0;

// The rank of the coordinator in case of a failure
int my_rank=0;

void *serv_handler(void *sockfd_arg){
	printf("entered\n");
	int sockfd;
	char recv_buf[10];
	sockfd = *((int *)sockfd_arg);
	
	printf("Connected to server with sockfd %d...\n", sockfd);

	recv(sockfd, recv_buf, 7, 0);

	printf("Message received ... %s\n", recv_buf);

}

void *incoming_handler(void *sockfd_arg){
	printf("entered\n");
	int sockfd;
	sockfd = *((int *)sockfd_arg);
	char *str = "Hello!";

	printf("Connection established at sockfd %d...\n", sockfd);
	
	send(sockfd, str, 7, 0);
	
	printf("Message sent.\n");

}

/*
 * This function adds a node element to the queue based on the rank
 
add_queue_elem(struct sockaddr *addr, int node_rank){
	coord_queue_elem_t *ptr;
	coord_queue_elem_t coord_elem;
	
	coord_elem.coord.address = *addr;
	coord_elem.rank=node_rank;
	coord_elem.next=NULL;
	coord_elem.prev=NULL;

	ptr = head;

	if(ptr == NULL){
		head = ptr = &coord_elem;
	}else{
		while(ptr != NULL && node_rank > ptr->rank){
			if(ptr->next == NULL);			
		}

		if(ptr->next == NULL){
			ptr->next = &coord_elem;			
		}

		if()

		
		
	}
	


}
*/

int main(int argc, char *argv[]){

	struct addrinfo *serv_info, *own_info;
	struct sockaddr_in incoming_addr;
	int serv_sockfd;
	int new_fd;
	int listen_sockfd;
	int retval;
	int incoming_next=0;
	pthread_t serv_thread, incoming_thread[MAX_CONNS], nodes_thread, usb_thread;

	
	// initialize usb
	init_interface();
	
	// Connect to server
	if(strcmp(argv[1], "0.0.0.0") != 0){
		
		// Get server information
		serv_info = get_addr_info(argv[1], PORT, AF_INET, SOCK_STREAM);
		if(serv_info == NULL){
			printf("Illegal server info.\n");
			exit(1);
		}

		// get socket
		serv_sockfd = get_socket(serv_info);
		if(serv_sockfd == -1){
			exit(1);
		}		

		printf("Connecting to server %s at port %s...\n", argv[1], PORT);
		retval = connect(serv_sockfd, serv_info->ai_addr, serv_info->ai_addrlen);
		if(retval){
			perror("Problem in connecting to the server...\n");
			exit(1);
		}
	
		// Add the server to the coordinator queue	
		//add_queue_elem(serv_info->ai_addr, rank);

		// Spawn a new thread to handle all the communications with the server
		retval = pthread_create(&serv_thread, NULL, serv_handler, (void *)&serv_sockfd);
		if(retval){
			perror("Thread error");
		}
		printf("after thread\n");		
	}else{ // I am the chief
		am_i_chief = 1;		
		if(lnp_init(0,0,0,0,0)){
			perror("lnp_init:");
			exit(1);
		}
		printf("lnp initialized...\n");
		usb_thread = pthread_create(&usb_thread, NULL, read_data, (void *)0); 
		nodes_thread = pthread_create(&nodes_thread, NULL, manage_nodes, (void *)0);
	}

	// Start our own listening thread
	own_info = get_addr_info("127.0.0.1", PORT, AF_INET, SOCK_STREAM);
	
	// get socket
	listen_sockfd = get_socket(own_info);

	printf("Binding socket...\n");
	retval = bind(listen_sockfd, own_info->ai_addr, own_info->ai_addrlen);
	if(retval){
		perror("Bind error: ");		
	}

	// listen to socket for incoming connections
	retval = listen(listen_sockfd, BACKLOG);
	if(retval){
		perror("listen error");
		exit(1);
	}

	printf("Waiting for connections...\n");		
	
	while(1){}
/*
		int size = sizeof(incoming_addr);
		
		new_fd = accept(listen_sockfd, (struct sockaddr *)&incoming_addr, &size);
		printf("Making it till here \n");
		printf("Accepting connection from %s:%d...\n", inet_ntoa(incoming_addr.sin_addr), ntohs(incoming_addr.sin_port));
		// Add the new sock addr to the coord queue
		
		retval = pthread_create(&incoming_thread[incoming_next++], NULL, incoming_handler, (void *)&new_fd);
		if(retval){
			perror("Listening thread error");
			exit(1);
		}

	}*/

	return 0;

}
