#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#ifndef COORD_H
#define COORD_H

// Structure for each machine node
typedef struct coord_node {
	struct sockaddr address;

} coord_node_t;

// Queue for a list of coordinators
typedef struct coord_queue{
	int rank;
	coord_node_t coord;
	struct coord_queue *next;
	struct coord_queue *prev;
} coord_queue_elem_t;

// head pointer to the head of the coordinator queue
//coord_queue_elem_t *head=NULL;

// Structures to maintain the network layout
struct mote_address {
	int mote_addr[2];
	struct mote_address *next;
};


typedef struct mote_struct {
	// Filename of the mote data file
	char filename[256];	
	// Address of mote itself
	struct mote_address address;
	// Address of connected motes
	struct mote_address *connections;
	// Busy flag. Decides whether mote will take place in routing or not.
	int busy;	
	// visited flag
	int visited;
	// failed flag
	int failed;
	struct mote_struct *next;
} mote_t; 

int manage_nodes(void *);

// lnpd packet
struct lnpd_pack{
	char a;
	char dest;
	char c;
};
 
// hard coded array for node positions


// initialize interface
int init_interface();
int read_data(void *arg);

#endif
