#include<stdio.h>
#include<stdlib.h>
#include "coord.h"
#include<string.h>
#define MANAGE_NW

mote_t *head,*tail;

#define READ_NODE 0
#define READ_CONN 1

#define ADD_NODE  0
#define FAIL_NODE 1

#define ADDR_PARTS	2
#define STR_ADDR_SIZE	3
#define MAX_CONN	10

struct mote_address *new_addr(int addr0, int addr1){
        struct mote_address *tmp;
        tmp = (struct mote_address *)malloc(sizeof(struct mote_address));
        tmp->next=NULL;
        tmp->mote_addr[0] = addr0;
        tmp->mote_addr[1] = addr1;

        return tmp	;
}

int add_addr(struct mote_address *conn, struct mote_address *new){
        while(conn->next != NULL){
                conn=conn->next;
        }
        conn->next = new;
}

void init_node(int *addr, int conn[][ADDR_PARTS], int no_conns){
        int i;
        char addr0[50], addr1[25];
        char dot[25] = ".";

        if(tail == NULL && head == NULL){
                printf("allocating request\n");
                head = (mote_t *)malloc(sizeof(mote_t));
                tail=head;
        }else{
                tail->next = (mote_t *)malloc(sizeof(mote_t));
                tail = tail->next;
        }

	tail->next=NULL;
	tail->visited=0;
	tail->failed=0;
        tail->connections = NULL;
        tail->address.mote_addr[0] = addr[0];
        tail->address.mote_addr[1] = addr[1];

        sprintf(addr0,"%d", addr[0]);
        sprintf(addr1,"%d", addr[1]);

        strcpy(tail->filename,strcat(addr0,strcat(dot, strcat(addr1,".node"))));
        printf("filname is %s\n", tail->filename);
        for(i=0;i<no_conns;i++){
                if(tail->connections == NULL){
                        tail->connections=new_addr(conn[i][0], conn[i][1]);
                }else{
                        add_addr(tail->connections, new_addr(conn[i][0], conn[i][1]));
                }
        }

}

mote_t *get_node_by_addr(struct mote_address *ptr){
	mote_t *tmp = head;

	while(tmp != NULL){
		if(tmp->address.mote_addr[0] == ptr->mote_addr[0] && tmp->address.mote_addr[1] == ptr->mote_addr[1]){
			return tmp;
		}
		tmp = tmp->next;
	}
	return NULL;
}

void dfs(mote_t *curr_node){
	struct mote_address *tmp_addr;
	mote_t *trav_node;
	curr_node->visited = 1;
	
	tmp_addr = curr_node->connections;
	while(tmp_addr != NULL){
		trav_node = get_node_by_addr(tmp_addr);
		if(trav_node->visited == 0 && trav_node->failed == 0){
			dfs(trav_node);
		}
		tmp_addr = tmp_addr->next;		
	}

}

void reset_visited(){
	mote_t *temp_node;
	
	temp_node = head;
	while(temp_node !=NULL){
		temp_node->visited=0;
		temp_node=temp_node->next;
	}

}

int fail_and_check_dfs(int *addr){
	mote_t *temp_node,*f_node;
	struct mote_address failed_node;
	
	failed_node.mote_addr[0] = addr[0];
	failed_node.mote_addr[1] = addr[1];
	
	f_node = get_node_by_addr(&failed_node);
	f_node->failed=1;

	reset_visited();

	temp_node = head;
			dfs(temp_node);


	// Check for isolation
	temp_node = head;
	while(temp_node != NULL){
		if(temp_node->visited == 0 && temp_node->failed == 0){
			struct lnpd_pack packet;
			int result;
			char *data;
			packet.a = 1;
			packet.dest = 2;		
			packet.c = 3;
			printf("Node %d.%d isolated. Sending recover mule\n", temp_node->address.mote_addr[0], temp_node->address.mote_addr[1]);

			data = (char *)&packet;
			// Sending to rcx
			result = lnp_integrity_write(data, sizeof(struct lnpd_pack));
			break;			
		}
		temp_node= temp_node->next;
	}

}

int manage_nodes(void *arg){
	
	head=tail=NULL;
	int i=0,j=0,k=0;
        int state=-1, main_state;
        int addr[ADDR_PARTS];
        char str_addr[ADDR_PARTS][STR_ADDR_SIZE];
        int conn_addr[MAX_CONN][ADDR_PARTS];
        int conn_index=0;
        int add_index=0;
        int c_index=0;
        char str[50];
        struct mote_address *tmp;
	
	while(1){
		scanf("%s", str);

		// initialize variables
		conn_index=0;
		add_index=0;
		c_index=0;
		i=j=k=0;

                for(i=0;i<strlen(str);i++){
                        if(str[i] == 'n'){
                                state = READ_NODE;
				main_state = ADD_NODE;
                        }else if(str[i] == 'c'){
                                state = READ_CONN;
			}else if(str[i] == 'd'){
				mote_t *iter_node,*temp_node;
				struct mote_address *temp_addr;
				iter_node=head;
				while(iter_node != NULL){
					printf("I am %d.%d\n", iter_node->address.mote_addr[0], iter_node->address.mote_addr[1]);
					temp_addr = iter_node->connections;
					while(temp_addr !=NULL){
						temp_node=get_node_by_addr(temp_addr);
						printf("%d.%d -> %s\n",  temp_node->address.mote_addr[0], temp_node->address.mote_addr[1], temp_node->filename);
						temp_addr = temp_addr->next;	
					}
					iter_node = iter_node->next;
				}	
				goto out;
                        }else if(str[i] == 'f'){
				main_state=FAIL_NODE;
				state=READ_NODE;
			}else{
                                if(state == READ_NODE){
                                        if(str[i] == '.' || str[i] == '&'){
                                                if(str[i] == '.');

                                                str_addr[add_index][j] = '\0';
                                                addr[add_index] = atoi(str_addr[add_index]);
                                                add_index++;
                                                j=0;
                                        }else{
                                                str_addr[add_index][j++] = str[i];
                                        }
                                }

                                if(state == READ_CONN){
                                        if(str[i] == '.' || str[i] == ',' || str[i] == '&'){
                                                if(str[i] == '.');

                                                str_addr[conn_index][k] = '\0';
                                                conn_addr[c_index][conn_index] = atoi(str_addr[conn_index]);
                                                conn_index++;
                                                k=0;
                                                if(str[i] == ',' || str[i] == '&') {
                                                        c_index++;
                                                        conn_index = 0;
                                                }
                                        }else{
                                                str_addr[conn_index][k++] = str[i];
                                        }
                                }
                        }
                }
		if(main_state == ADD_NODE){
	                init_node(addr, conn_addr, c_index);
		}else if(main_state == FAIL_NODE){
			printf("Node failed %d.%d\n",addr[0], addr[1]);
			fail_and_check_dfs(addr);
		}

                printf("The tail node\n");
                printf("Address: %d.%d\n", tail->address.mote_addr[0], tail->address.mote_addr[1]);
                printf("Filename: %s\n", tail->filename);
                printf("The connections: \n");
                tmp=tail->connections;
                while(tmp != NULL){
                        printf("%d.%d\n", tmp->mote_addr[0], tmp->mote_addr[1]);
                        tmp = tmp->next;
                }

	}	
out:	
	return 0;

}

