#define _GNU_SOURCE
#include<stdio.h>
#include<fcntl.h>
#include<unistd.h>
#include<termios.h>
#include<sys/time.h>
#include<errno.h>
#include<stdlib.h>

#define DEVICE "/dev/ttyUSB0"
#define RATE   B115200

int fd;

int init_interface(){
        struct termios options;
        fd_set mask, smask;
        int i;
        char *device=DEVICE;
        speed_t speed = B115200;
        unsigned char buff[256];
        int n, flags;

	printf("Connecting to device ... %s\n", device);
        fd = open(device, O_RDWR);// | O_NOCTTY | O_NDELAY | O_DIRECT | O_SYNC );
        if(fd <0){
                perror("error in opening file:");
                exit(-1);
        }

        printf("Connected.\n");

        if (fcntl(fd, F_SETFL, 0) < 0) {
                perror("could not set fcntl");
                exit(-1);
        }

        if (tcgetattr(fd, &options) < 0) {
                perror("could not get options");
                exit(-1);
        }

        /*   fprintf(stderr, "serial options set\n"); */
        cfsetispeed(&options, speed);
        cfsetospeed(&options, speed);
        /* Enable the receiver and set local mode */
        options.c_cflag |= (CLOCAL | CREAD);
        /* Mask the character size bits and turn off (odd) parity */
        options.c_cflag &= ~(CSIZE|PARENB|PARODD);
        /* Select 8 data bits */
        options.c_cflag |= CS8;

        /* Raw input */
        options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
        /* Raw output */
        options.c_oflag &= ~OPOST;

        if (tcsetattr(fd, TCSANOW, &options) < 0) {
            perror("could not set options");
            exit(-1);
        }
	return 0;	
}

int read_data(void *arg){
	fd_set mask, smask;
	int n,i;
	char buff[256];

	FD_ZERO(&mask);
	FD_SET(fd, &mask);

	for(;;){
	//	while(data_processing == 1);
		smask = mask;
		n = select(FD_SETSIZE, &smask, (fd_set *)0, (fd_set *)0, (struct timeval *)0);
		if(n<0){
			perror("select:");
			exit(1);
		}
		if(FD_ISSET(fd, &smask)){
                        int num;
                        num = read(fd, buff, sizeof(buff));
                        if(num < 0){
                                perror("read:");
                                exit(1);
                        }

                        for(i=0;i<num;i++){
                                printf("%c", buff[i]);
                        }
                        fflush(stdout);
                }
	}
}
