#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "nw_setup.h"

int yes=1;

/*
 * function to get address information of the server/own. 
 * If server information is needed the ip will be the ip address of server.
 * If own information is neede then ip will be NULL.
 */  
struct addrinfo *get_addr_info(char *ip, char *port, int family, int socktype){
	struct addrinfo hints, *result;
	int retval=0;

	// clear hints
	memset(&hints, 0, sizeof(hints));

	// set parameters for hints
	hints.ai_family = family;
	hints.ai_socktype = socktype;

	// get address info for server
	retval = getaddrinfo(NULL, "3048", &hints, &result);
	if(retval != 0){ 
		fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(retval));
		return NULL;	
	}

	return result;
}



/*
 * function to get socket with specified options
 */
int get_socket(struct addrinfo *sock_info){
	int sock;
	int retval;	

	sock = socket(sock_info->ai_family, sock_info->ai_socktype, sock_info->ai_protocol);
	if(sock == -1){
		perror("Error in creating socket: ");
		return -1;
	}
	
	retval = setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int));
	if(retval == -1){
		perror("Error in setting sock options: ");
		exit(-1);
	}	
	
	return sock;
}
